> For the complete documentation index, see [llms.txt](https://docs.nexthink.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nexthink.com/user-guide/spark/spark-nql-capabilities.md).

# Spark NQL capabilities

Use Nexthink Query Language (NQL) in the [Investigations](/user-guide/investigations/creating-investigations/nql-editor.md) module to access Spark conversations data.

The system stores each conversation in the `agent.conversations` NQL table. Refer to [NQL data model > Namespace agent](/understanding-key-data-platform-concepts/nql-data-model.md#agent) for more details on available fields.

The following are examples of common NQL queries:

<details>

<summary>Key Spark KPIs</summary>

Retrieve key Spark KPIs from the last 30 days, such as the number of active users, total number of conversations and the number of conversations that are currently active.

{% code overflow="wrap" lineNumbers="true" %}

```
agent.conversations during past 30d
| summarize active_users = user.count(), total_conversations = conversation_id.count(), active_conversations = conversation_id.countif((state == in_progress or state == null))
```

{% endcode %}

</details>

<details>

<summary>Conversation number and duration per device</summary>

Retrieve the number of conversations and avarage conversation duration per device.

```
devices during past 30d
| include agent.conversations during past 30d
| where agent.conversations.outcome in [resolved, escalated]
| compute number_of_conversations_ = conversations.number_of_conversations.sum(), average_resolution_time = agent.conversations.conversation_duration.avg()
| where number_of_conversations_ != 0
| where average_resolution_time != 0
| list device.name, device.entity, device.hardware.model, device.hardware.type, device.operating_system.name, number_of_conversations_, average_resolution_time
| sort number_of_conversations_ desc
```

</details>

<details>

<summary>Resolved conversations by resolution reason</summary>

Retrieve the number of resolved conversations in the last 7 days broken down by resolution reason.

{% code overflow="wrap" lineNumbers="true" %}

```
agent.conversations during past 7d
| where outcome == resolved
| summarize number_of_conversations_by_reason = count() by reason
```

{% endcode %}

</details>

RELATED TOPICS

* [Monitoring Spark](/user-guide/spark/working-with-spark/monitoring-spark.md)
* [NQL data model](/understanding-key-data-platform-concepts/nql-data-model.md#agent)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.nexthink.com/user-guide/spark/spark-nql-capabilities.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
